require "dotenv/load"
require "slack_mattermost_emoji/slack_client"

RSpec.describe SlackMattermostEmoji::SlackClient do
  it 'should be able to log in to slack using the provided credentials' do
    client = SlackMattermostEmoji::SlackClient.new(
      username: ENV['SLACK_USERNAME'],
      password: ENV['SLACK_PASSWORD'],
      domain: ENV['SLACK_DOMAIN']
    )
    client.authenticate

    expect(client.authenticated?).to be true
  end

  it 'should handle a bad credentials error' do
    client = SlackMattermostEmoji::SlackClient.new(
      username: ENV['SLACK_USERNAME'],
      password: 'wrongpassword',
      domain: ENV['SLACK_DOMAIN']
    )
    expect { client.authenticate }.to raise_error('Invalid credentials')
  end
end
